from typing import Any, Container, Dict, Generic, Iterable, Iterator, List, Optional, Set, Tuple, TypeVar, Union
from . import QtCore


from PySide2.QtGui import QStringListModel as _QStringListModel
from PySide2.QtWidgets import QTreeView as _QTreeView
from PySide2.QtWidgets import QWidget as _QWidget
from PySide2.QtWidgets import QListView as _QListView
from PySide2.QtCore import QObject as _QObject
from PySide2.QtCore import QAbstractItemModel as _QAbstractItemModel


if False:
    from typing import Dict, List, Tuple, Union, Optional

class _Object(object):
    __dict__ : dictproxy


class QHelpIndexWidget(_QListView):
    def activateCurrentItem(*args, **kwargs): ...
    def filterIndices(*args, **kwargs): ...
    linkActivated : PySide2.QtCore.Signal
    
    linksActivated : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpSearchQuery(_Object):
    def __copy__(*args, **kwargs): ...
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    ALL : FieldName
    
    ATLEAST : FieldName
    
    DEFAULT : FieldName
    
    FUZZY : FieldName
    
    FieldName : Type[FieldName]
    
    PHRASE : FieldName
    
    WITHOUT : FieldName
    
    __new__ : builtin_function_or_method
    
    fieldName : getset_descriptor
    
    wordList : getset_descriptor


class QHelpContentModel(_QAbstractItemModel):
    def columnCount(*args, **kwargs): ...
    def contentItemAt(*args, **kwargs): ...
    def createContents(*args, **kwargs): ...
    def data(*args, **kwargs): ...
    def index(*args, **kwargs): ...
    def isCreatingContents(*args, **kwargs): ...
    def parent(*args, **kwargs): ...
    def rowCount(*args, **kwargs): ...
    contentsCreated : PySide2.QtCore.Signal
    
    contentsCreationStarted : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpContentItem(_Object):
    def __copy__(*args, **kwargs): ...
    def child(*args, **kwargs): ...
    def childCount(*args, **kwargs): ...
    def childPosition(*args, **kwargs): ...
    def parent(*args, **kwargs): ...
    def row(*args, **kwargs): ...
    def title(*args, **kwargs): ...
    def url(*args, **kwargs): ...


class QHelpEngineCore(_QObject):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def addCustomFilter(*args, **kwargs): ...
    def autoSaveFilter(*args, **kwargs): ...
    def collectionFile(*args, **kwargs): ...
    def copyCollectionFile(*args, **kwargs): ...
    def currentFilter(*args, **kwargs): ...
    def customFilters(*args, **kwargs): ...
    def customValue(*args, **kwargs): ...
    def documentationFileName(*args, **kwargs): ...
    def error(*args, **kwargs): ...
    def fileData(*args, **kwargs): ...
    def files(*args, **kwargs): ...
    def filterAttributeSets(*args, **kwargs): ...
    def filterAttributes(*args, **kwargs): ...
    def findFile(*args, **kwargs): ...
    def linksForIdentifier(*args, **kwargs): ...
    def registerDocumentation(*args, **kwargs): ...
    def registeredDocumentations(*args, **kwargs): ...
    def removeCustomFilter(*args, **kwargs): ...
    def removeCustomValue(*args, **kwargs): ...
    def setAutoSaveFilter(*args, **kwargs): ...
    def setCollectionFile(*args, **kwargs): ...
    def setCurrentFilter(*args, **kwargs): ...
    def setCustomValue(*args, **kwargs): ...
    def setupData(*args, **kwargs): ...
    def unregisterDocumentation(*args, **kwargs): ...
    @staticmethod
    def metaData(*args, **kwargs): ...
    @staticmethod
    def namespaceName(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    currentFilterChanged : PySide2.QtCore.Signal
    
    readersAboutToBeInvalidated : PySide2.QtCore.Signal
    
    setupFinished : PySide2.QtCore.Signal
    
    setupStarted : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject
    
    warning : PySide2.QtCore.Signal


class QHelpSearchResultWidget(_QWidget):
    def changeEvent(*args, **kwargs): ...
    def linkAt(*args, **kwargs): ...
    requestShowLink : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpContentWidget(_QTreeView):
    def indexOf(*args, **kwargs): ...
    linkActivated : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpSearchQueryWidget(_QWidget):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def changeEvent(*args, **kwargs): ...
    def collapseExtendedSearch(*args, **kwargs): ...
    def expandExtendedSearch(*args, **kwargs): ...
    def focusInEvent(*args, **kwargs): ...
    def isCompactMode(*args, **kwargs): ...
    def query(*args, **kwargs): ...
    def setCompactMode(*args, **kwargs): ...
    def setQuery(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    search : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpIndexModel(_QStringListModel):
    def createIndex(*args, **kwargs): ...
    def filter(*args, **kwargs): ...
    def isCreatingIndex(*args, **kwargs): ...
    def linksForKeyword(*args, **kwargs): ...
    indexCreated : PySide2.QtCore.Signal
    
    indexCreationStarted : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpSearchEngine(_QObject):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def cancelIndexing(*args, **kwargs): ...
    def cancelSearching(*args, **kwargs): ...
    def hitCount(*args, **kwargs): ...
    def hits(*args, **kwargs): ...
    def hitsCount(*args, **kwargs): ...
    def query(*args, **kwargs): ...
    def queryWidget(*args, **kwargs): ...
    def reindexDocumentation(*args, **kwargs): ...
    def resultWidget(*args, **kwargs): ...
    def search(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    indexingFinished : PySide2.QtCore.Signal
    
    indexingStarted : PySide2.QtCore.Signal
    
    searchingFinished : PySide2.QtCore.Signal
    
    searchingStarted : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QHelpEngine(QHelpEngineCore):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def contentModel(*args, **kwargs): ...
    def contentWidget(*args, **kwargs): ...
    def indexModel(*args, **kwargs): ...
    def indexWidget(*args, **kwargs): ...
    def searchEngine(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    staticMetaObject : PySide2.QtCore.QMetaObject



