from typing import Any, Container, Dict, Generic, Iterable, Iterator, List, Optional, Set, Tuple, TypeVar, Union
from . import QtCore


from PySide2.QtWidgets import QDialog as _QDialog
from PySide2.QtGui import QPagedPaintDevice as _QPagedPaintDevice
from PySide2.QtWidgets import QWidget as _QWidget


if False:
    from typing import Dict, List, Tuple, Union, Optional

class _Object(object):
    __dict__ : dictproxy


class QPrintPreviewDialog(_QDialog):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def done(*args, **kwargs): ...
    def open(*args, **kwargs): ...
    def printer(*args, **kwargs): ...
    def setVisible(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    paintRequested : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QPrinter(_QPagedPaintDevice):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def abort(*args, **kwargs): ...
    def actualNumCopies(*args, **kwargs): ...
    def collateCopies(*args, **kwargs): ...
    def colorMode(*args, **kwargs): ...
    def copyCount(*args, **kwargs): ...
    def creator(*args, **kwargs): ...
    def devType(*args, **kwargs): ...
    def docName(*args, **kwargs): ...
    def doubleSidedPrinting(*args, **kwargs): ...
    def duplex(*args, **kwargs): ...
    def fontEmbeddingEnabled(*args, **kwargs): ...
    def fromPage(*args, **kwargs): ...
    def fullPage(*args, **kwargs): ...
    def getPageMargins(*args, **kwargs): ...
    def isValid(*args, **kwargs): ...
    def metric(*args, **kwargs): ...
    def newPage(*args, **kwargs): ...
    def numCopies(*args, **kwargs): ...
    def orientation(*args, **kwargs): ...
    def outputFileName(*args, **kwargs): ...
    def outputFormat(*args, **kwargs): ...
    def pageOrder(*args, **kwargs): ...
    def pageRect(*args, **kwargs): ...
    def pageSize(*args, **kwargs): ...
    def paintEngine(*args, **kwargs): ...
    def paperName(*args, **kwargs): ...
    def paperRect(*args, **kwargs): ...
    def paperSize(*args, **kwargs): ...
    def paperSource(*args, **kwargs): ...
    def printEngine(*args, **kwargs): ...
    def printProgram(*args, **kwargs): ...
    def printRange(*args, **kwargs): ...
    def printerName(*args, **kwargs): ...
    def printerState(*args, **kwargs): ...
    def resolution(*args, **kwargs): ...
    def setCollateCopies(*args, **kwargs): ...
    def setColorMode(*args, **kwargs): ...
    def setCopyCount(*args, **kwargs): ...
    def setCreator(*args, **kwargs): ...
    def setDocName(*args, **kwargs): ...
    def setDoubleSidedPrinting(*args, **kwargs): ...
    def setDuplex(*args, **kwargs): ...
    def setEngines(*args, **kwargs): ...
    def setFontEmbeddingEnabled(*args, **kwargs): ...
    def setFromTo(*args, **kwargs): ...
    def setFullPage(*args, **kwargs): ...
    def setMargins(*args, **kwargs): ...
    def setNumCopies(*args, **kwargs): ...
    def setOrientation(*args, **kwargs): ...
    def setOutputFileName(*args, **kwargs): ...
    def setOutputFormat(*args, **kwargs): ...
    def setPageMargins(*args, **kwargs): ...
    def setPageOrder(*args, **kwargs): ...
    def setPageSize(*args, **kwargs): ...
    def setPageSizeMM(*args, **kwargs): ...
    def setPaperName(*args, **kwargs): ...
    def setPaperSize(*args, **kwargs): ...
    def setPaperSource(*args, **kwargs): ...
    def setPrintProgram(*args, **kwargs): ...
    def setPrintRange(*args, **kwargs): ...
    def setPrinterName(*args, **kwargs): ...
    def setResolution(*args, **kwargs): ...
    def setWinPageSize(*args, **kwargs): ...
    def supportedPaperSources(*args, **kwargs): ...
    def supportedResolutions(*args, **kwargs): ...
    def supportsMultipleCopies(*args, **kwargs): ...
    def toPage(*args, **kwargs): ...
    def winPageSize(*args, **kwargs): ...
    Aborted : PrinterState
    
    Active : PrinterState
    
    AllPages : PrintRange
    
    Auto : PaperSource
    
    Cassette : PaperSource
    
    Cicero : Unit
    
    Color : ColorMode
    
    ColorMode : Type[ColorMode]
    
    CurrentPage : PrintRange
    
    CustomSource : PaperSource
    
    DevicePixel : Unit
    
    Didot : Unit
    
    DuplexAuto : DuplexMode
    
    DuplexLongSide : DuplexMode
    
    DuplexMode : Type[DuplexMode]
    
    DuplexNone : DuplexMode
    
    DuplexShortSide : DuplexMode
    
    Envelope : PaperSource
    
    EnvelopeManual : PaperSource
    
    Error : PrinterState
    
    FirstPageFirst : PageOrder
    
    FormSource : PaperSource
    
    GrayScale : ColorMode
    
    HighResolution : PrinterMode
    
    Idle : PrinterState
    
    Inch : Unit
    
    Landscape : Orientation
    
    LargeCapacity : PaperSource
    
    LargeFormat : PaperSource
    
    LastPageFirst : PageOrder
    
    LastPaperSource : PaperSource
    
    Lower : PaperSource
    
    Manual : PaperSource
    
    MaxPageSource : PaperSource
    
    Middle : PaperSource
    
    Millimeter : Unit
    
    NativeFormat : OutputFormat
    
    OnlyOne : PaperSource
    
    Orientation : Type[Orientation]
    
    OutputFormat : Type[OutputFormat]
    
    PageOrder : Type[PageOrder]
    
    PageRange : PrintRange
    
    PaperSource : Type[PaperSource]
    
    PdfFormat : OutputFormat
    
    Pica : Unit
    
    Point : Unit
    
    Portrait : Orientation
    
    PrintRange : Type[PrintRange]
    
    PrinterMode : Type[PrinterMode]
    
    PrinterResolution : PrinterMode
    
    PrinterState : Type[PrinterState]
    
    ScreenResolution : PrinterMode
    
    Selection : PrintRange
    
    SmallFormat : PaperSource
    
    Tractor : PaperSource
    
    Unit : Type[Unit]
    
    Upper : PaperSource
    
    __new__ : builtin_function_or_method


class QPageSetupDialog(_QDialog):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def done(*args, **kwargs): ...
    def exec_(*args, **kwargs): ...
    def open(*args, **kwargs): ...
    def printer(*args, **kwargs): ...
    def setVisible(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QPrinterInfo(_Object):
    def __copy__(*args, **kwargs): ...
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def __nonzero__(self) -> bool:
        """
        x.__nonzero__() <==> x != 0
        """
        ...
    def defaultDuplexMode(*args, **kwargs): ...
    def description(*args, **kwargs): ...
    def isDefault(*args, **kwargs): ...
    def isNull(*args, **kwargs): ...
    def isRemote(*args, **kwargs): ...
    def location(*args, **kwargs): ...
    def makeAndModel(*args, **kwargs): ...
    def printerName(*args, **kwargs): ...
    def state(*args, **kwargs): ...
    def supportedDuplexModes(*args, **kwargs): ...
    def supportedResolutions(*args, **kwargs): ...
    def supportedSizesWithNames(*args, **kwargs): ...
    def supportsCustomPageSizes(*args, **kwargs): ...
    @staticmethod
    def availablePrinterNames(*args, **kwargs): ...
    @staticmethod
    def availablePrinters(*args, **kwargs): ...
    @staticmethod
    def defaultPrinter(*args, **kwargs): ...
    @staticmethod
    def defaultPrinterName(*args, **kwargs): ...
    @staticmethod
    def printerInfo(*args, **kwargs): ...
    __new__ : builtin_function_or_method


class QAbstractPrintDialog(_QDialog):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def addEnabledOption(*args, **kwargs): ...
    def enabledOptions(*args, **kwargs): ...
    def exec_(*args, **kwargs): ...
    def fromPage(*args, **kwargs): ...
    def isOptionEnabled(*args, **kwargs): ...
    def maxPage(*args, **kwargs): ...
    def minPage(*args, **kwargs): ...
    def printRange(*args, **kwargs): ...
    def printer(*args, **kwargs): ...
    def setEnabledOptions(*args, **kwargs): ...
    def setFromTo(*args, **kwargs): ...
    def setMinMax(*args, **kwargs): ...
    def setOptionTabs(*args, **kwargs): ...
    def setPrintRange(*args, **kwargs): ...
    def toPage(*args, **kwargs): ...
    AllPages : PrintRange
    
    CurrentPage : PrintRange
    
    DontUseSheet : PrintDialogOption
    
    locals()['None'] : PrintDialogOption
    
    PageRange : PrintRange
    
    PrintCollateCopies : PrintDialogOption
    
    PrintCurrentPage : PrintDialogOption
    
    PrintDialogOption : Type[PrintDialogOption]
    
    PrintDialogOptions : Type[PrintDialogOptions]
    
    PrintPageRange : PrintDialogOption
    
    PrintRange : Type[PrintRange]
    
    PrintSelection : PrintDialogOption
    
    PrintShowPageSize : PrintDialogOption
    
    PrintToFile : PrintDialogOption
    
    Selection : PrintRange
    
    __new__ : builtin_function_or_method
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QPrintPreviewWidget(_QWidget):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def currentPage(*args, **kwargs): ...
    def fitInView(*args, **kwargs): ...
    def fitToWidth(*args, **kwargs): ...
    def orientation(*args, **kwargs): ...
    def pageCount(*args, **kwargs): ...
    def print_(*args, **kwargs): ...
    def setAllPagesViewMode(*args, **kwargs): ...
    def setCurrentPage(*args, **kwargs): ...
    def setFacingPagesViewMode(*args, **kwargs): ...
    def setLandscapeOrientation(*args, **kwargs): ...
    def setOrientation(*args, **kwargs): ...
    def setPortraitOrientation(*args, **kwargs): ...
    def setSinglePageViewMode(*args, **kwargs): ...
    def setViewMode(*args, **kwargs): ...
    def setVisible(*args, **kwargs): ...
    def setZoomFactor(*args, **kwargs): ...
    def setZoomMode(*args, **kwargs): ...
    def updatePreview(*args, **kwargs): ...
    def viewMode(*args, **kwargs): ...
    def zoomFactor(*args, **kwargs): ...
    def zoomIn(*args, **kwargs): ...
    def zoomMode(*args, **kwargs): ...
    def zoomOut(*args, **kwargs): ...
    AllPagesView : ViewMode
    
    CustomZoom : ZoomMode
    
    FacingPagesView : ViewMode
    
    FitInView : ZoomMode
    
    FitToWidth : ZoomMode
    
    SinglePageView : ViewMode
    
    ViewMode : Type[ViewMode]
    
    ZoomMode : Type[ZoomMode]
    
    __new__ : builtin_function_or_method
    
    paintRequested : PySide2.QtCore.Signal
    
    previewChanged : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject


class QPrintEngine(_Object):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def abort(*args, **kwargs): ...
    def metric(*args, **kwargs): ...
    def newPage(*args, **kwargs): ...
    def printerState(*args, **kwargs): ...
    def property(*args, **kwargs): ...
    def setProperty(*args, **kwargs): ...
    PPK_CollateCopies : PrintEnginePropertyKey
    
    PPK_ColorMode : PrintEnginePropertyKey
    
    PPK_CopyCount : PrintEnginePropertyKey
    
    PPK_Creator : PrintEnginePropertyKey
    
    PPK_CustomBase : PrintEnginePropertyKey
    
    PPK_CustomPaperSize : PrintEnginePropertyKey
    
    PPK_DocumentName : PrintEnginePropertyKey
    
    PPK_Duplex : PrintEnginePropertyKey
    
    PPK_FontEmbedding : PrintEnginePropertyKey
    
    PPK_FullPage : PrintEnginePropertyKey
    
    PPK_NumberOfCopies : PrintEnginePropertyKey
    
    PPK_Orientation : PrintEnginePropertyKey
    
    PPK_OutputFileName : PrintEnginePropertyKey
    
    PPK_PageMargins : PrintEnginePropertyKey
    
    PPK_PageOrder : PrintEnginePropertyKey
    
    PPK_PageRect : PrintEnginePropertyKey
    
    PPK_PageSize : PrintEnginePropertyKey
    
    PPK_PaperName : PrintEnginePropertyKey
    
    PPK_PaperRect : PrintEnginePropertyKey
    
    PPK_PaperSize : PrintEnginePropertyKey
    
    PPK_PaperSource : PrintEnginePropertyKey
    
    PPK_PaperSources : PrintEnginePropertyKey
    
    PPK_PrinterName : PrintEnginePropertyKey
    
    PPK_PrinterProgram : PrintEnginePropertyKey
    
    PPK_QPageLayout : PrintEnginePropertyKey
    
    PPK_QPageMargins : PrintEnginePropertyKey
    
    PPK_QPageSize : PrintEnginePropertyKey
    
    PPK_Resolution : PrintEnginePropertyKey
    
    PPK_SelectionOption : PrintEnginePropertyKey
    
    PPK_SupportedResolutions : PrintEnginePropertyKey
    
    PPK_SupportsMultipleCopies : PrintEnginePropertyKey
    
    PPK_WindowsPageSize : PrintEnginePropertyKey
    
    PrintEnginePropertyKey : Type[PrintEnginePropertyKey]
    
    __new__ : builtin_function_or_method


class QPrintDialog(QAbstractPrintDialog):
    def __init__(*args, **kwargs):
        """
        x.__init__(...) initializes x; see help(type(x)) for signature
        """
        ...
    def accept(*args, **kwargs): ...
    def done(*args, **kwargs): ...
    def exec_(*args, **kwargs): ...
    def open(*args, **kwargs): ...
    def options(*args, **kwargs): ...
    def printer(*args, **kwargs): ...
    def setOption(*args, **kwargs): ...
    def setOptions(*args, **kwargs): ...
    def setVisible(*args, **kwargs): ...
    def testOption(*args, **kwargs): ...
    __new__ : builtin_function_or_method
    
    accepted : PySide2.QtCore.Signal
    
    staticMetaObject : PySide2.QtCore.QMetaObject



