from typing import Any, Container, Dict, Generic, Iterable, Iterator, List, Optional, Set, Tuple, TypeVar, Union
import pymel.util as util


from maya.OpenMayaRender import *
from maya.OpenMayaMPx import *
from maya.OpenMaya import *
from maya.OpenMayaUI import *


from maya.OpenMayaAnim import MFnBlendShapeDeformer
from maya.OpenMayaAnim import MFnWireDeformer
from maya.OpenMayaAnim import MIkSystem
from maya.OpenMayaFX import MFnGravityField
from pymel.api.allapi import isValidMDagNode
from maya.OpenMayaAnim import MAnimCurveClipboardItemArray
from maya.OpenMayaFX import MnRigid
from maya.OpenMayaAnim import MFnKeyframeDeltaAddRemove
from maya.OpenMayaFX import MFnFluid
from maya.OpenMayaAnim import MFnHikEffector
from pymel.api.allapi import toMDagPath
from pymel.api.allapi import toMPlug
from maya.OpenMayaFX import MDynamicsUtil
from maya.OpenMayaAnim import MFnKeyframeDelta
from maya.OpenMayaAnim import MFnIkEffector
from maya.OpenMayaFX import MFnInstancer
from pymel.api.allapi import MItGraph
from maya.OpenMayaAnim import MFnKeyframeDeltaScale
from maya.OpenMayaAnim import MFnKeyframeDeltaInfType
from maya.OpenMayaFX import MRenderLineArray
from maya.OpenMayaAnim import MFnGeometryFilter
from maya.OpenMayaFX import MDynSweptLine
from pymel.api.allapi import toComponentMObject
from maya.OpenMayaAnim import MAnimCurveClipboardItem
from maya.OpenMayaAnim import MFnCharacter
from maya.OpenMayaFX import MnParticle
from maya.OpenMayaFX import MFnAirField
from maya.OpenMayaFX import MFnVortexField
from maya.OpenMayaFX import MDynSweptTriangle
from maya.OpenMayaFX import MnSolver
from pymel.api.allapi import isValidMDagPath
from maya.OpenMayaAnim import MFnWeightGeometryFilter
from maya.OpenMayaAnim import MFnIkHandle
from maya.OpenMayaFX import MFnParticleSystem
from maya.OpenMayaAnim import MFnLatticeDeformer
from maya.OpenMayaFX import MnObject
from maya.OpenMayaFX import MFnField
from maya.OpenMayaFX import MFnTurbulenceField
from pymel.api.allapi import isValidMNodeOrPlug
from maya.OpenMayaAnim import MAnimCurveClipboard
from maya.OpenMayaAnim import MAnimMessage
from pymel.api.allapi import SafeApiPtr
from maya.OpenMayaAnim import MFnLattice
from maya.OpenMayaFX import MFnDynSweptGeometryData
from pymel.api.allapi import MItDag
from maya.OpenMayaFX import MFnNewtonField
from maya.OpenMayaFX import MHairSystem
from pymel.api.allapi import toApiObject
from pymel.api.allapi import isValidMNode
from maya.OpenMayaAnim import MFnKeyframeDeltaMove
from maya.OpenMayaAnim import MFnMotionPath
from maya.OpenMayaAnim import MFnKeyframeDeltaBlockAddRemove
from maya.OpenMayaAnim import MFnAnimCurve
from maya.OpenMayaAnim import MAnimUtil
from maya.OpenMayaAnim import MIkHandleGroup
from maya.OpenMayaAnim import MFnClip
from maya.OpenMayaFX import MFnNObjectData
from maya.OpenMayaFX import MFnVolumeAxisField
from pymel.api.allapi import isValidMPlug
from maya.OpenMayaAnim import MFnIkJoint
from maya.OpenMayaFX import MnCloth
from maya.OpenMayaAnim import MAnimControl
from maya.OpenMayaFX import MFnDragField
from pymel.api.allapi import MObjectName
from maya.OpenMayaAnim import MFnKeyframeDeltaWeighted
from pymel.api.allapi import toMObject
from pymel.api.allapi import nameToMObject
from maya.OpenMayaAnim import MFnKeyframeDeltaTangent
from maya.OpenMayaFX import MFnRadialField
from maya.OpenMayaFX import MFnUniformField
from maya.OpenMayaAnim import MFnSkinCluster
from pymel.api.allapi import MItNodes
from maya.OpenMayaFX import MFnPfxGeometry
from maya.OpenMayaAnim import MAnimCurveChange
from maya.OpenMayaAnim import MItKeyframe
from maya.OpenMayaFX import MRenderLine
from maya.OpenMayaAnim import MFnIkSolver
from pymel.api.allapi import getPlugValue
from maya.OpenMayaAnim import MFnKeyframeDeltaBreakdown
from maya.OpenMayaFX import MFnNIdData
from pymel.api.allapi import isValidMObjectHandle
from pymel.api.allapi import isValidMObject


if False:
    from typing import Dict, List, Tuple, Union, Optional

def MHairSystem_registeringCallableScript(*args, **kwargs): ...
def MIkSystem_setGlobalSolve(*args, **kwargs): ...
def MAnimControl_isPlaying(*args, **kwargs): ...
def MFnDynSweptGeometryData_className(*args, **kwargs): ...
def MFnField_className(*args, **kwargs): ...
def MFnTurbulenceField_swigregister(*args, **kwargs): ...
def MFnDragField_className(*args, **kwargs): ...
def MAnimControl_globalInTangentType(*args, **kwargs): ...
def MFnSkinCluster_className(*args, **kwargs): ...
def MAnimControl_setGlobalInTangentType(*args, **kwargs): ...
def MnParticle_swigregister(*args, **kwargs): ...
def MAnimCurveChange_swigregister(*args, **kwargs): ...
def MHairSystem_unregisterCollisionSolverPreFrame(*args, **kwargs): ...
def MIkSystem_getSolvers(*args, **kwargs): ...
def MAnimControl_autoKeyMode(*args, **kwargs): ...
def MDynSweptLine_className(*args, **kwargs): ...
def MAnimUtil_findAnimationLayers(*args, **kwargs): ...
def MHairSystem_setRegisteringCallableScript(*args, **kwargs): ...
def MFnHikEffector_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaTangent_className(*args, **kwargs): ...
def MIkHandleGroup_swigregister(*args, **kwargs): ...
def MFnFluid_swigregister(*args, **kwargs): ...
def MFnVortexField_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaBlockAddRemove_swigregister(*args, **kwargs): ...
def MAnimControl_playBackward(*args, **kwargs): ...
def MAnimUtil_findAnimation(*args, **kwargs): ...
def MAnimControl_playbackBy(*args, **kwargs): ...
def MAnimCurveClipboardItem_className(*args, **kwargs): ...
def MFnAirField_className(*args, **kwargs): ...
def MFnKeyframeDeltaTangent_swigregister(*args, **kwargs): ...
def MFnVolumeAxisField_className(*args, **kwargs): ...
def MFnSkinCluster_swigregister(*args, **kwargs): ...
def MAnimControl_playbackMode(*args, **kwargs): ...
def MAnimControl_stop(*args, **kwargs): ...
def MAnimCurveClipboard_theAPIClipboard(*args, **kwargs): ...
def MAnimControl_swigregister(*args, **kwargs): ...
def MFnVortexField_className(*args, **kwargs): ...
def MFnKeyframeDeltaScale_swigregister(*args, **kwargs): ...
def MFnLattice_swigregister(*args, **kwargs): ...
def MAnimControl_setCurrentTime(*args, **kwargs): ...
def MFnIkHandle_className(*args, **kwargs): ...
def MFnNewtonField_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaWeighted_swigregister(*args, **kwargs): ...
def MFnIkJoint_swigregister(*args, **kwargs): ...
def MFnNObjectData_className(*args, **kwargs): ...
def MFnKeyframeDeltaMove_swigregister(*args, **kwargs): ...
def MIkSystem_className(*args, **kwargs): ...
def MFnHikEffector_className(*args, **kwargs): ...
def MAnimControl_globalOutTangentType(*args, **kwargs): ...
def MFnBlendShapeDeformer_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaBlockAddRemove_className(*args, **kwargs): ...
def MDynamicsUtil_runupIfRequired(*args, **kwargs): ...
def MFnNObjectData_swigregister(*args, **kwargs): ...
def MFnKeyframeDelta_className(*args, **kwargs): ...
def MFnLatticeDeformer_className(*args, **kwargs): ...
def MFnCharacter_className(*args, **kwargs): ...
def MFnWeightGeometryFilter_swigregister(*args, **kwargs): ...
def MFnClip_swigregister(*args, **kwargs): ...
def MFnPfxGeometry_swigregister(*args, **kwargs): ...
def MHairSystem_getCollisionObject(*args, **kwargs): ...
def MIkSystem_isGlobalSnap(*args, **kwargs): ...
def MFnAnimCurve_className(*args, **kwargs): ...
def MAnimControl_setAutoKeyMode(*args, **kwargs): ...
def MFnWireDeformer_swigregister(*args, **kwargs): ...
def MAnimUtil_className(*args, **kwargs): ...
def MRenderLineArray_className(*args, **kwargs): ...
def MAnimControl_setMaxTime(*args, **kwargs): ...
def MAnimMessage_addAnimKeyframeEditCheckCallback(*args, **kwargs): ...
def MIkSystem_setGlobalSnap(*args, **kwargs): ...
def MFnPfxGeometry_className(*args, **kwargs): ...
def MFnMotionPath_swigregister(*args, **kwargs): ...
def MAnimControl_setPlaybackMode(*args, **kwargs): ...
def MFnKeyframeDeltaMove_className(*args, **kwargs): ...
def MFnIkJoint_className(*args, **kwargs): ...
def MHairSystem_registerCollisionSolverCollide(*args, **kwargs): ...
def MIkHandleGroup_className(*args, **kwargs): ...
def MnRigid_swigregister(*args, **kwargs): ...
def MAnimMessage_addPostBakeResultsCallback(*args, **kwargs): ...
def MAnimUtil_findSetDrivenKeyAnimation(*args, **kwargs): ...
def MFnAirField_swigregister(*args, **kwargs): ...
def MAnimControl_setPlaybackBy(*args, **kwargs): ...
def MFnDynSweptGeometryData_swigregister(*args, **kwargs): ...
def MAnimCurveClipboardItem_swigregister(*args, **kwargs): ...
def MAnimControl_maxTime(*args, **kwargs): ...
def MHairSystem_unregisterCollisionSolverCollide(*args, **kwargs): ...
def MItKeyframe_swigregister(*args, **kwargs): ...
def MFnIkHandle_swigregister(*args, **kwargs): ...
def MDynSweptTriangle_className(*args, **kwargs): ...
def MAnimControl_playbackSpeed(*args, **kwargs): ...
def MDynamicsUtil_swigregister(*args, **kwargs): ...
def MAnimMessage_swigregister(*args, **kwargs): ...
def MFnBlendShapeDeformer_className(*args, **kwargs): ...
def MFnInstancer_className(*args, **kwargs): ...
def MDynSweptLine_swigregister(*args, **kwargs): ...
def MnObject_swigregister(*args, **kwargs): ...
def MDynamicsUtil_addNodeTypeToRunup(*args, **kwargs): ...
def MFnGravityField_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaInfType_className(*args, **kwargs): ...
def MFnDragField_swigregister(*args, **kwargs): ...
def MAnimControl_setGlobalOutTangentType(*args, **kwargs): ...
def MFnVolumeAxisField_swigregister(*args, **kwargs): ...
def MAnimUtil_isAnimated(*args, **kwargs): ...
def MAnimControl_setAnimationEndTime(*args, **kwargs): ...
def MFnIkEffector_swigregister(*args, **kwargs): ...
def MFnGeometryFilter_swigregister(*args, **kwargs): ...
def MAnimMessage_flushAnimKeyframeEditedCallbacks(*args, **kwargs): ...
def MAnimMessage_addAnimCurveEditedCallback(*args, **kwargs): ...
def MDynSweptTriangle_swigregister(*args, **kwargs): ...
def MAnimMessage_addNodeAnimKeyframeEditedCallback(*args, **kwargs): ...
def MFnClip_className(*args, **kwargs): ...
def MFnLattice_className(*args, **kwargs): ...
def MAnimControl_setMinMaxTime(*args, **kwargs): ...
def MAnimMessage_addPreBakeResultsCallback(*args, **kwargs): ...
def MFnIkSolver_swigregister(*args, **kwargs): ...
def MAnimControl_setMinTime(*args, **kwargs): ...
def MRenderLine_className(*args, **kwargs): ...
def MAnimMessage_addDisableImplicitControlCallback(*args, **kwargs): ...
def MFnNIdData_className(*args, **kwargs): ...
def MAnimMessage_className(*args, **kwargs): ...
def MHairSystem_registerCollisionSolverPreFrame(*args, **kwargs): ...
def MAnimControl_isScrubbing(*args, **kwargs): ...
def MAnimUtil_findConstraint(*args, **kwargs): ...
def MAnimControl_minTime(*args, **kwargs): ...
def MFnTurbulenceField_className(*args, **kwargs): ...
def MAnimCurveClipboardItemArray_className(*args, **kwargs): ...
def MFnField_swigregister(*args, **kwargs): ...
def MFnInstancer_swigregister(*args, **kwargs): ...
def MFnParticleSystem_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaInfType_swigregister(*args, **kwargs): ...
def MFnNIdData_swigregister(*args, **kwargs): ...
def MAnimControl_setPlaybackSpeed(*args, **kwargs): ...
def MDynamicsUtil_hasValidDynamics2dTexture(*args, **kwargs): ...
def MAnimControl_viewMode(*args, **kwargs): ...
def MFnUniformField_swigregister(*args, **kwargs): ...
def MDynamicsUtil_evalDynamics2dTexture(*args, **kwargs): ...
def MAnimControl_weightedTangents(*args, **kwargs): ...
def MFnNewtonField_className(*args, **kwargs): ...
def MFnIkSolver_className(*args, **kwargs): ...
def MAnimControl_setAnimationStartEndTime(*args, **kwargs): ...
def MDynamicsUtil_removeNodeTypeFromRunup(*args, **kwargs): ...
def MFnFluid_className(*args, **kwargs): ...
def MDynamicsUtil_inRunup(*args, **kwargs): ...
def MIkSystem_isGlobalSolve(*args, **kwargs): ...
def MFnKeyframeDeltaBreakdown_swigregister(*args, **kwargs): ...
def MAnimUtil_swigregister(*args, **kwargs): ...
def MFnIkEffector_className(*args, **kwargs): ...
def MFnGravityField_className(*args, **kwargs): ...
def MIkSystem_findSolver(*args, **kwargs): ...
def MFnKeyframeDeltaBreakdown_className(*args, **kwargs): ...
def MFnCharacter_swigregister(*args, **kwargs): ...
def MnCloth_swigregister(*args, **kwargs): ...
def MFnKeyframeDelta_swigregister(*args, **kwargs): ...
def MAnimUtil_findAnimatablePlugs(*args, **kwargs): ...
def MFnLatticeDeformer_swigregister(*args, **kwargs): ...
def MRenderLineArray_swigregister(*args, **kwargs): ...
def MAnimMessage_addAnimKeyframeEditedCallback(*args, **kwargs): ...
def MFnKeyframeDeltaWeighted_className(*args, **kwargs): ...
def MFnWeightGeometryFilter_className(*args, **kwargs): ...
def MAnimCurveClipboardItemArray_swigregister(*args, **kwargs): ...
def MFnAnimCurve_swigregister(*args, **kwargs): ...
def MAnimCurveClipboard_swigregister(*args, **kwargs): ...
def MFnKeyframeDeltaAddRemove_swigregister(*args, **kwargs): ...
def MFnMotionPath_className(*args, **kwargs): ...
def MRenderLine_swigregister(*args, **kwargs): ...
def MAnimControl_playForward(*args, **kwargs): ...
def MAnimUtil_findAnimatedPlugs(*args, **kwargs): ...
def MFnKeyframeDeltaAddRemove_className(*args, **kwargs): ...
def MHairSystem_getFollicle(*args, **kwargs): ...
def MHairSystem_className(*args, **kwargs): ...
def MFnParticleSystem_className(*args, **kwargs): ...
def MAnimControl_setViewMode(*args, **kwargs): ...
def MAnimControl_animationStartTime(*args, **kwargs): ...
def MFnRadialField_swigregister(*args, **kwargs): ...
def MAnimControl_animationEndTime(*args, **kwargs): ...
def MFnKeyframeDeltaScale_className(*args, **kwargs): ...
def MAnimControl_setAnimationStartTime(*args, **kwargs): ...
def MHairSystem_swigregister(*args, **kwargs): ...
def MIkSystem_swigregister(*args, **kwargs): ...
def MFnUniformField_className(*args, **kwargs): ...
def MAnimControl_setWeightedTangents(*args, **kwargs): ...
def MAnimControl_currentTime(*args, **kwargs): ...
def MItKeyframe_className(*args, **kwargs): ...
def MnSolver_swigregister(*args, **kwargs): ...
def MFnWireDeformer_className(*args, **kwargs): ...
def MAnimCurveChange_className(*args, **kwargs): ...
def MFnGeometryFilter_className(*args, **kwargs): ...
def MFnRadialField_className(*args, **kwargs): ...

